注册 登录  
 加关注
   显示下一条  |  关闭
温馨提示!由于新浪微博认证机制调整,您的新浪微博帐号绑定已过期,请重新绑定!立即重新绑定新浪微博》  |  关闭

断尘居

温柔的男人像海洋。

 
 
 
 
 

日志

 
 

关于应用程序中类冲突或者类版本不对的问题  

2011-11-23 14:46:25|  分类: JDK |  标签: |举报 |字号 订阅

  下载LOFTER 我的照片书  |

一般因为jar包冲突或者jar包版本的问题,导致应用程序中发生以下类似异常:
(1)、ClassNotFoundException
(2)、ClassCastException
(3)、java.lang.UnsupportedClassVersionError
(4)、java.lang.AbstractMethodError
(5)、ClassLoader相关的异常
等等。

出现此类问题时的分析解决思路:
首先,需要确认发生异常时,对应类的jar是否已经存在或者提供,以免真正的ClassNotFoundException发生,
不是因为jar没加载上,而是因为本身的jar就没有提供。
其次,需要通过java的-verbose监测,应用服务器加载的jar的路径,是否是我们期望的jar包路径。
这里有可能有相同包名+类名的类存在于其他jar包中,以免应用服务器加载了我们不期望的类,而导致
真正想加载的类没有加载上,因为:一旦一个类被载入JVM中,同一个类就不会被再次载入了(切记,同一个类是指类的全路径,即:
包路径+类名称)。
在这个环节中,可以通过开发人员来了解,发生异常时,类对应的jar包是哪个?!如果不知道的话,可以通过工具:TotalCommand去检索
应用中所有的jar包,看错误类是从哪些jar包来的。
最后,剔除掉多余的jar包,只留下适合应用的或者我们期望的jar包,让应用服务器去加载。

提示:以下是经常用到的类加载器:classLoader
(1)、java.lang.ClassLoader
(2)、sun.misc.Launcher.ExtClassLoader==>java.ext.dirs
(3)、AppClassLoader==>java.class.path
(4)、java.net.URLClassLoader
(5)、java.security.SecureClassLoader
(6)、java.rmi.server.RMIClassLoader
(7)、sun.applet.AppletClassLoader

  评论这张
 
阅读(512)| 评论(0)
推荐 转载

历史上的今天

在LOFTER的更多文章

评论

<#--最新日志,群博日志--> <#--推荐日志--> <#--引用记录--> <#--博主推荐--> <#--随机阅读--> <#--首页推荐--> <#--历史上的今天--> <#--被推荐日志--> <#--上一篇,下一篇--> <#-- 热度 --> <#-- 网易新闻广告 --> <#--右边模块结构--> <#--评论模块结构--> <#--引用模块结构--> <#--博主发起的投票-->
 
 
 
 
 
 
 
 
 
 
 
 
 
 

页脚

网易公司版权所有 ©1997-2017